/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.webProj.service;

import cnam.webProj.model.ForumMessage;
import cnam.webProj.model.ForumUser;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author rosmord
 */
@Stateless
public class MessageService {

    @PersistenceContext
    EntityManager em;

    public Long create(String title, String content, ForumUser author) {
        // User object will be disconnected, and we might find it better to reconnect 
        // him. But it's not mandatory, either.
        //ForumMessage m= new ForumMessage(title, content, em.merge(author));
        ForumMessage m = new ForumMessage(title, content, author);
        em.persist(m);
        em.flush(); // ensure id is ok.
        return m.getId();
    }

    
    public void update(Long id, String title, String content) {
        ForumMessage m= em.find(ForumMessage.class, id);
        if (m != null) {
            m.setTitle(title);
            m.setContent(content);
        }
    }
    
    public void delete(ForumMessage m) {
        em.remove(m);
    }

    public ForumMessage getMessageById(Long id) {
        /**
         * Returns a messsage along with its author.
         */
        return em.createQuery("select m from ForumMessage m JOIN FETCH m.user where m.id = :id", 
                ForumMessage.class).setParameter("id", id).getSingleResult();
    }

    public List<ForumMessage> getAll() {
        return em.createQuery("select m from ForumMessage m", ForumMessage.class).getResultList();
    }

}
