/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.webProj.service;

import cnam.webProj.model.ForumGroup;
import cnam.webProj.model.ForumUser;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author rosmord
 */
@Stateless
public class UserService {

    @PersistenceContext
    EntityManager em;

    public void create(ForumUser user) {
        em.persist(user);
    }

    public ForumUser create(String login, String password, ForumGroup group) {
        ForumUser user = new ForumUser(login, password, group);
        create(user);
        return user;
    }

    public ForumUser update(ForumUser user) {
        return em.merge(user);
    }

    public void delete(ForumUser user) {
        em.remove(user);
    }

    public ForumUser getUser(String login) {
        return em.find(ForumUser.class, login);
    }

    public List<ForumUser> getAll() {
        return em.createQuery("select u from ForumUser u", ForumUser.class).getResultList();
    }

    public boolean hasUsers() {
        long count = em.createQuery("select COUNT(DISTINCT u) from ForumUser u", Long.class).getSingleResult();
        return count != 0l;
    }

    /**
     * Update a user, knowing his login.
     * @param login
     * @param password
     * @param forumGroup 
     */
    public void update(String login, String password, ForumGroup forumGroup) {
        ForumUser u= getUser(login);
        if (u != null) {            
            u.setPassword(password);
            u.setForumGroup(forumGroup);
        }
    }

}
