/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.webProj.ui;

import cnam.webProj.model.ForumGroup;
import cnam.webProj.model.ForumMessage;
import cnam.webProj.model.ForumUser;
import java.io.Serializable;
import javax.ejb.Remove;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

/**
 *
 * @author rosmord
 */
@Named
@SessionScoped
public class UserConnection implements Serializable {
    private ForumUser currentUser;

    public UserConnection() {
        System.err.println("Creating user connection bean");
    }

    
    public ForumUser getCurrentUser() {
        return currentUser;
    }

    public void setCurrentUser(ForumUser currentUser) {
        this.currentUser = currentUser;
    }
    
    public boolean getHasUser() {
        return currentUser != null;
    }
    
    /**
     * Returns true if the current user has administration rights.
     * @return 
     */
    public boolean getHasAdminRights() {
        return getHasUser() && currentUser.getForumGroup().equals(ForumGroup.ADMIN);
    }
    @Remove
    public String logout() {        
        currentUser= null;
        return "index";
    }

    /**
     * Check if the current user is a given, known user.
     * @param login the login to test.
     * @return true if user login is connected.
     */
    public boolean isUser(String login) {
        if (getHasUser()) {
            return getCurrentUser().getLogin().equals(login);
        } else {
            return false;
        }
    }


    public boolean canEditMessageOf(String authorLogin) {
        return authorLogin != null && currentUser != null && (getHasAdminRights() || authorLogin.equals(currentUser.getLogin()));
    }
}
