/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.webProj.ui.message;

import cnam.webProj.model.ForumMessage;
import cnam.webProj.service.MessageService;
import cnam.webProj.ui.MessageHelper;
import cnam.webProj.ui.UserConnection;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author rosmord
 */
@Named
@RequestScoped
public class MessageEditBean {

    @Inject
    UserConnection userConnection;

    @Inject
    MessageService messageService;

    private Long id;

    private String title, content;

    private String authorLogin;

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String Content) {
        this.content = Content;
    }

    public String edit(Long id) {
        this.id = id;
        ForumMessage m = messageService.getMessageById(id);
        if (m != null) {
            this.authorLogin= m.getUser().getLogin();
            if (userConnection.canEditMessageOf(authorLogin)) {
                this.title = m.getTitle();
                this.content = m.getContent();
                this.authorLogin = m.getUser().getLogin();
                return "messageEdit";
            } else {
                MessageHelper.addErrorMessage("Can't edit message");
                return "failure";
            }
        } else {
            MessageHelper.addErrorMessage("No such message");
            return "failure";
        }
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public boolean hasCanEdit() {
        return userConnection.canEditMessageOf(authorLogin);
    }

    public String getAuthorLogin() {
        return authorLogin;
    }

    public void setAuthorLogin(String authorLogin) {
        this.authorLogin = authorLogin;
    }
    
    
    

    public String update() {
        if (hasCanEdit()) {
            messageService.update(id, title, content);
            return "success";
        } else {
            MessageHelper.addErrorMessage("No right to edit this message.");
            return "failure";
        }
    }

}
