/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cnam.webProj.ui.user;

import cnam.webProj.model.ForumGroup;
import cnam.webProj.model.ForumUser;
import cnam.webProj.service.UserService;
import cnam.webProj.ui.MessageHelper;
import cnam.webProj.ui.UserConnection;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author rosmord
 */
@Named
@RequestScoped
public class UserEditBean {

    @Inject // or @EJB
    UserService userService;

    @Inject
    UserConnection userConnection;

    private String login="";
    private String password1="", password2="";
    private ForumGroup forumGroup=ForumGroup.USER;


    
    public String edit(String login) {
        boolean ok = false;
        String resultPage;
        this.login = login;
        if (getCanEditUser()) {
            ForumUser u = userService.getUser(login);
            password1 = u.getPassword();
            password2 = u.getPassword();
            forumGroup = u.getForumGroup();
            resultPage = "userEdit";
        } else {
            MessageHelper.addErrorMessage("Can't edit this user");
            resultPage = "failure";
        }
        return resultPage;
    }

    public boolean getCanEditUser() {      
        return userConnection.getHasUser() 
                && (
                userConnection.getHasAdminRights()
                || userConnection.isUser(login));
    }

    public String update() {
        if (getCanEditUser()) {
            if (password1.equals(password2)) {
                // If the current user has no admin rights, he can't give
                // them.
                if (!userConnection.getHasAdminRights()) {
                    forumGroup = ForumGroup.USER;
                }
                userService.update(login, password1, forumGroup);
                return "success";
            } else {
                MessageHelper.addErrorMessage("Passwords must match !");
                return "failure";
            }
        } else {
            MessageHelper.addErrorMessage("Could not edit this user !");
            return "failure";
        }
    }

    public String getLogin() {
        return login;
    }

    public void setLogin(String login) {
        this.login = login;
    }

    public String getPassword1() {
        return password1;
    }

    public void setPassword1(String password1) {
        this.password1 = password1;
    }

    public String getPassword2() {
        return password2;
    }

    public void setPassword2(String password2) {
        this.password2 = password2;
    }

    public ForumGroup getForumGroup() {
        return forumGroup;
    }

    public void setForumGroup(ForumGroup forumGroup) {
        this.forumGroup = forumGroup;
    }

    public ForumGroup[] getAllGroups() {
        return ForumGroup.values();
    }

}
